/**
 * Copyright (C) 2011 Red Hat, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package io.fabric8.kubernetes.api.model;

import com.fasterxml.jackson.core.JsonProcessingException;
import org.junit.Test;

import static org.junit.Assert.assertEquals;

public class InlineTest {

    @Test
    public void testIntOrString() throws JsonProcessingException {
        ServicePort port = new ServicePortBuilder().withNewTargetPort(2181).build();
        assertEquals(2181, port.getTargetPort().getIntVal().intValue());

        port = new ServicePortBuilder().withNewTargetPort("2181").build();
        assertEquals("2181", port.getTargetPort().getStrVal());
    }
}